'
' ####################
' #####  PROLOG  #####
' ####################
'
' Change integer from LSB to MSB endian.
' big-endian = MSB (most significant byte first (Motorola)
' little-endian = LSB (least significant byte first (Intel x86)  

CONSOLE

'	IMPORT "xst"				' Standard library : required by most programs

DECLARE FUNCTION Entry ()
DECLARE FUNCTION Endianise (@value, size)

FUNCTION Entry ()

	x = 0xABC146D9
	PRINT "LSB: "; HEXX$ (x, 8)
	
	y = Endianise (x, 4)
	PRINT "MSB: "; HEXX$ (y, 8)

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
'
' ##########################
' #####  Endianise ()  #####
' ##########################
'
FUNCTION  Endianise (value, size)

	SELECT CASE size ' Do we have a 2-byte or 4 byte integer?

		CASE 2
			result = 0
		  result = result OR ((value >> 8) AND 0x00FF)
		  result = result OR ((value << 8) AND 0xFF00)
			value = result

		CASE 4
			result = 0
		  result = result OR ((value >> 24) AND 0x000000FF)
		  result = result OR ((value >> 08) AND 0x0000FF00)
		  result = result OR ((value << 08) AND 0x00FF0000)
		  result = result OR ((value << 24) AND 0xFF000000)
			value = result
			
		CASE ELSE
			RETURN

	END SELECT

	RETURN value

END FUNCTION
END PROGRAM