
' A multidimensional array demo.

VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

DECLARE FUNCTION Entry ()
DECLARE FUNCTION Dimensions (array[])

FUNCTION Entry ()

	' construct a 3 dimensional array using XstBuildDataArray()
	' note that {} enclosing brackets are required for all multi-dimensional arrays
	data$ = "{{{23,45,22},{67,89,44}},{{49,12,29},{37,18,52}}}"
	ret = XstBuildDataArray( @x[], data$, $$XLONG)
	
	' how many dimensions in our array?
	dim = Dimensions (@x[])
	? "x[]" has"; dim; " dimensions
	
	up0 = UBOUND(x[])
	? "UBOUND(x[])="; up0
	
	up1 = UBOUND(x[up0, ])
	? "UBOUND(x[up0, ])="; up1
	
	up2 = UBOUND(x[up0,up1, ])
	? "UBOUND(x[up0,up1, ])"; up2

	' x[] is x[1,1,2]	
	? "x[] is probably x[";up0; "," up1; ","; up2; "]"
	
	' data will be in highest dimension	
	' grab x[1,0, ] and put it in t[]
	' t[] must be empty before calling ATTACH!
	IF x[1,0, ] THEN 
		
		ATTACH x[1,0, ] TO t[]

		? "data in x[1,0 ]:"
		FOR i = 0 TO UBOUND(t[])
			PRINT t[i];
		NEXT i
		PRINT
	
		' now put it back where we found it ;-)
		' there should always be (2) matching ATTACH statements
		ATTACH t[] TO x[1,0,]
	END IF
	
	' ok, now look at x[1,1, ]
	IF x[1,1 ] THEN
		
		ATTACH x[1,1, ] TO t[]

		? "data in x[1,1 ]:"
		FOR i = 0 TO UBOUND(t[])
			PRINT t[i];
		NEXT i
		?

		' now put it back
		ATTACH t[] TO x[1,1,]
	END IF
	
	?
	
	' for a regular array like this one, you can access the array as normal
	IFZ ret THEN
		FOR i = 0 TO 1
			FOR j = 0 TO 1
				FOR k = 0 TO 2
					PRINT "x[";i; ","; j; ","; k; "]="; x[i,j,k]
				NEXT k
			NEXT j
		NEXT i
	END IF 
	?

	?
  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

' ###########################
' ##### Dimensions () #####
' ###########################
'
' Returns a count of the number of dimensions in a regular array.
' usage: count = Dimensions (@x[])
'
FUNCTION Dimensions (array[])

	IFZ array[] THEN RETURN 0
	
	IF XstIsDataDimension (@array[]) THEN RETURN 1
	
	ATTACH array[0,] TO temp[]
	count = Dimensions (@temp[])
	ATTACH temp[] TO array[0,]
	RETURN (count + 1)

END FUNCTION

END PROGRAM