'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Example of using static control as a persistant drawing container
' (similar to VB picture box control).
'
' Also see the canvas custom control.
'
VERSION	"0.0001"

	IMPORT  "xst_s.lib"
	IMPORT  "xsx_s.lib"
'	IMPORT  "xio_s.lib"
'	IMPORT	"xst"   		' standard library	: required by most programs
'	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library

DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()

DECLARE FUNCTION StartDraw        (hWnd)
DECLARE FUNCTION EndDraw          (hWnd, hdc)

DECLARE FUNCTION DrawFloodFill    (hWnd, x, y, borderColor, fillColor, drawHDC)
DECLARE FUNCTION DrawPixel        (hWnd, x, y, pen, drawHDC)
DECLARE FUNCTION DrawLine         (hWnd, x1, y1, x2, y2, pen, drawHDC)
DECLARE FUNCTION DrawLineTo 			(hWnd, x, y, pen, drawHDC)
DECLARE FUNCTION DrawArc 					(hWnd, left, top, right, bottom, bcx, bcy, ecx, ecy, pen, drawHDC)
DECLARE FUNCTION DrawRectangle 		(hWnd, left, top, right, bottom, pen, fill, drawHDC)
DECLARE FUNCTION DrawRoundRect 		(hWnd, left, top, right, bottom, w, h, pen, fill, drawHDC)
DECLARE FUNCTION DrawEllipse 			(hWnd, left, top, right, bottom, pen, fill, drawHDC)

$$IDC_CANVAS = 100
$$IDC_BUTTON = 101
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry

	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	PAINTSTRUCT ps
	RECT rect

	SELECT CASE msg

		CASE $$WM_CREATE :
			hCanvas = NewChild ("static", "", $$SS_BITMAP | $$WS_BORDER, 10, 45, 350, 300, hWnd, $$IDC_CANVAS, 0)	
			hButton = NewChild ("button", "Draw Something", $$BS_PUSHBUTTON | $$WS_TABSTOP, 10, 10, 150, 24, hWnd, $$IDC_BUTTON, 0)	

		CASE $$WM_COMMAND :
			id         = LOWORD(wParam)
			SELECT CASE id
				CASE $$IDC_BUTTON
					hCanvas = GetDlgItem (hWnd, $$IDC_CANVAS)
					
					' get device context 
					hDestDC = StartDraw (hCanvas)
					
					' draw some stuff
					DrawFloodFill (0, 0, 0, XstRandomRGB (), XstRandomRGB (), hDestDC)
					DrawEllipse (0, 30, 10, 320, 100, XstRandomRGB (), $$TRUE, hDestDC)
					DrawPixel (0, 2, 2, XstRandomRGB (), hDestDC)
					DrawLine (0, 5, 5, 300, 250, XstRandomRGB (), hDestDC)
					DrawLineTo (0, 300, 5, XstRandomRGB (), hDestDC)
					DrawArc (0, 290, 290, 130, 150, 95, 95, 130, 70, XstRandomRGB (), hDestDC)
					DrawRectangle (0, 40, 240, 100, 100, XstRandomRGB (), $$TRUE, hDestDC)
					DrawRoundRect (0, 160, 180, 100, 150, 20, 20, XstRandomRGB (), $$TRUE, hDestDC)

					
					' copy to canvas
					EndDraw (hCanvas, hDestDC)
					
			END SELECT

		CASE $$WM_DESTROY :
			PostQuitMessage(0)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library
	
END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	' create main window
	titleBar$ 	= "Simple Canvas using Static Control"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 400
	h 					= 400
	exStyle			= 0
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc
	
	className$ = titleBar$
	IFZ className$ THEN className$ = "Main Program"
	IF INSTR(className$, " ") THEN
		XstReplace (@className$, " ", "_", 0)
	END IF
	
	IFZ icon$ THEN icon$ = "scrabble"
	
	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
' #######################
' #####  StartDraw  #####
' #######################
'
'
'
FUNCTION StartDraw (hWnd)

	RECT rc

	newbmp = SendMessageA (hWnd, $$STM_GETIMAGE, 0, 0)
	IFZ newbmp THEN
		GetClientRect (hWnd, &rc)
		winDC = GetDC (NULL)
		newbmp = CreateCompatibleBitmap (winDC, rc.right, rc.bottom)
		ReleaseDC (NULL, winDC)
	ELSE
		newbmp = CopyImage (newbmp, $$IMAGE_BITMAP, 0, 0, $$LR_COPYRETURNORG)
	END IF
	hDestDC = CreateCompatibleDC (0)
	oldbmp = SelectObject (hDestDC, newbmp)
	SetPropA (hWnd, &"oldbmp", oldbmp)
	
	RETURN hDestDC

END FUNCTION
'
' #####################
' #####  EndDraw  #####
' #####################
'
'
'
FUNCTION EndDraw (hWnd, hdc)

	oldbmp = GetPropA (hWnd, &"oldbmp")
	newbmp = SelectObject (hdc, oldbmp)
	DeleteDC (hdc)
	bm = SendMessageA (hWnd, $$STM_SETIMAGE, $$IMAGE_BITMAP, newbmp)
	RETURN newbmp

END FUNCTION
'
' ###########################
' #####  DrawFloodFill  #####
' ###########################
'
'
'
FUNCTION DrawFloodFill (hWnd, x, y, borderColor, fillColor, drawHDC)

	IF (!drawHDC) THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hNPen = CreatePen ($$PS_SOLID, 1, fillColor)
	hOPen = SelectObject (drawHDC, hNPen)
	hNewBrush = CreateSolidBrush (fillColor)
	hOldBrush = SelectObject (drawHDC, hNewBrush)
	a = ExtFloodFill (drawHDC, x, y, borderColor, 0)
	DeleteObject (SelectObject (drawHDC, hOPen))
	DeleteObject (SelectObject (drawHDC, hOldBrush))
	IF (b) THEN ReleaseDC (hWnd, DrawHDC)
	RETURN a

END FUNCTION
'
' #######################
' #####  DrawPixel  #####
' #######################
'
'
'
FUNCTION DrawPixel (hWnd, x, y, pen, drawHDC)

	hNPen = CreatePen ($$PS_SOLID, 1, pen)
	IF (!drawHDC)THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hOPen = SelectObject (drawHDC, hNPen)
	a = SetPixelV (drawHDC, x, y, pen)
	DeleteObject (SelectObject (drawHDC, hOPen))
	IF (b)THEN ReleaseDC (hWnd, drawHDC)
	RETURN a

END FUNCTION
'
' ######################
' #####  DrawLine  #####
' ######################
'
'
'
FUNCTION DrawLine (hWnd, x1, y1, x2, y2, pen, drawHDC)

	hNPen = CreatePen ($$PS_SOLID, 1, pen)
	IF (!drawHDC) THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hOPen = SelectObject (drawHDC, hNPen)
	MoveToEx (drawHDC, x1, y1, NULL)
	a = LineTo (drawHDC, x2, y2)
	DeleteObject (SelectObject (drawHDC, hOPen))
	IF (b) THEN ReleaseDC (hWnd, drawHDC)
	RETURN a

END FUNCTION
'
' ########################
' #####  DrawLineTo  #####
' ########################
'
'
'
FUNCTION DrawLineTo (hWnd, x, y, pen, drawHDC)

	hNPen = CreatePen ($$PS_SOLID, 1, pen)
	IF (!drawHDC) THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hOPen = SelectObject (drawHDC, hNPen)
	a = LineTo (drawHDC, x, y)
	DeleteObject (SelectObject (drawHDC, hOPen))
	IF (b)THEN ReleaseDC (hWnd, drawHDC)
	RETURN a

END FUNCTION
'
' #####################
' #####  DrawArc  #####
' #####################
'
'
'
FUNCTION DrawArc (hWnd, left, top, right, bottom, bcx, bcy, ecx, ecy, pen, drawHDC)

	IF (!drawHDC) THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hNPen = CreatePen ($$PS_SOLID, 1, pen)
	hOPen = SelectObject (drawHDC, hNPen)
	a = Arc (drawHDC, left, top, right, bottom, bcx, bcy, ecx, ecy)
	DeleteObject (SelectObject (drawHDC, hOPen))
	IF (b) THEN ReleaseDC (hWnd, drawHDC)
	RETURN a

END FUNCTION
'
' ###########################
' #####  DrawRectangle  #####
' ###########################
'
'
'
FUNCTION DrawRectangle (hWnd, left, top, right, bottom, pen, fill, drawHDC)

	IF (!drawHDC) THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hNPen = CreatePen ($$PS_SOLID, 1, pen)
	hOPen = SelectObject (drawHDC, hNPen)
	IF (fill) THEN
		hNewBrush = CreateSolidBrush (pen)
		hOldBrush = SelectObject (drawHDC, hNewBrush)
	ELSE
		hNewBrush = GetStockObject ($$NULL_BRUSH)
		hOldBrush = SelectObject (drawHDC, hNewBrush)
	END IF
	a = Rectangle (drawHDC, left, top, right, bottom)
	DeleteObject (SelectObject (drawHDC, hOPen))
	DeleteObject (SelectObject (drawHDC, hOldBrush))
	IF (b) THEN ReleaseDC (hWnd, drawHDC)
	RETURN a

END FUNCTION
'
' ###########################
' #####  DrawRoundRect  #####
' ###########################
'
'
'
FUNCTION DrawRoundRect (hWnd, left, top, right, bottom, w, h, pen, fill, drawHDC)

	IF (!drawHDC) THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hNPen = CreatePen ($$PS_SOLID, 1, pen)
	hOPen = SelectObject (DrawHDC, hNPen)
	IF (fill) THEN
		hNewBrush = CreateSolidBrush (pen)
		hOldBrush = SelectObject (drawHDC, hNewBrush)
	ELSE
		hNewBrush = GetStockObject ($$NULL_BRUSH)
		hOldBrush = SelectObject (drawHDC, hNewBrush)
	END IF
	a = RoundRect (drawHDC, left, top, right, bottom, w, h)
	DeleteObject (SelectObject (drawHDC, hOPen))
	DeleteObject (SelectObject (drawHDC, hOldBrush))
	IF (b) THEN ReleaseDC (hWnd, drawHDC)
	RETURN a

END FUNCTION
'
' #########################
' #####  DrawEllipse  #####
' #########################
'
'
'
FUNCTION DrawEllipse (hWnd, left, top, right, bottom, pen, fill, drawHDC)

	IF (!drawHDC) THEN
		drawHDC = GetDC (hWnd)
		b = 1
	END IF
	hNPen = CreatePen ($$PS_SOLID, 1, pen)
	hOPen = SelectObject (drawHDC, hNPen)
	IF (fill)
	hNewBrush = CreateSolidBrush (pen)
	hOldBrush = SelectObject (drawHDC, hNewBrush)
	ELSE
		hNewBrush = GetStockObject ($$NULL_BRUSH)
		hOldBrush = SelectObject (drawHDC, hNewBrush)
	END IF
	a = Ellipse (drawHDC, left, top, right, bottom)
	DeleteObject (SelectObject (drawHDC, hOPen))
	DeleteObject (SelectObject (drawHDC, hOldBrush))
	IF (b) THEN ReleaseDC (hWnd, drawHDC)
	RETURN a

END FUNCTION

END PROGRAM
