'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A gui program using wide (unicode) functions.
'
VERSION	"0.0001"

	IMPORT  "xst_s.lib"
	IMPORT  "xsx_s.lib"
'	IMPORT	"xst"   		' standard library	: required by most programs
'	IMPORT  "xsx"				' extended std library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll

DECLARE FUNCTION Main 								()
DECLARE FUNCTION CreateWindows 				()
DECLARE FUNCTION RegisterWindowClass 	()
DECLARE FUNCTION WndProc 							(hWnd, msg, wParam, lParam)
DECLARE FUNCTION ButtonWndProc 				(hWnd, msg, wParam, lParam)

FUNCTION Main ()

	MSG msg
	SHARED hInst, appName$, className$
	
	hInst = GetModuleHandleA (0)
	className$ = XstAnsiToUnicode$ ("MyClassName")
	appName$   = XstAnsiToUnicode$ ("My Window Caption")
 
	IFZ RegisterWindowClass () THEN RETURN
 
	IF CreateWindows () THEN
		DO WHILE GetMessageW (&msg, 0, 0, 0)
			TranslateMessage (&msg)
			DispatchMessageW (&msg)
		LOOP
	END IF

	UnregisterClassW (&className$, hInst)

END FUNCTION

FUNCTION CreateWindows ()

	SHARED hInst, appName$, className$
	SHARED mainHwnd, buttonHwnd, editHwnd 
	SHARED butOldProc

	mainHwnd   = CreateWindowExW (0, &className$, &appName$, $$WS_OVERLAPPEDWINDOW, 200, 200, 208, 150, 0, 0, hInst, 0)

	className$ = XstAnsiToUnicode$ ("button")
	wndName$   = XstAnsiToUnicode$ ("Click Here")
	buttonHwnd = CreateWindowExW (0, &className$, &wndName$, $$WS_CHILD, 58, 90, 85, 25, mainHwnd, 0, hInst, 0)

	className$ = XstAnsiToUnicode$ ("edit")
	wndName$   = XstAnsiToUnicode$ ("This is the edit control.\r\nAs you can see, it's multiline.")	
	editHwnd   = CreateWindowExW ($$WS_EX_CLIENTEDGE, &className$, &wndName$, $$WS_CHILD | $$ES_MULTILINE, 0, 0, 200, 80, mainHwnd, 0, hInst, 0)

	ShowWindow (mainHwnd, $$SW_SHOWNORMAL)
	ShowWindow (buttonHwnd, $$SW_SHOWNORMAL)
	ShowWindow (editHwnd, $$SW_SHOWNORMAL)
 
	butOldProc = GetWindowLongW (buttonHwnd, $$GWL_WNDPROC)

	SetWindowLongW (buttonHwnd, $$GWL_WNDPROC, &ButtonWndProc())

	RETURN (mainHwnd <> 0)

END FUNCTION

FUNCTION RegisterWindowClass ()

	SHARED hInst, appName$, className$

	WNDCLASS wc
 
	wc.style 					= $$CS_HREDRAW | $$CS_VREDRAW
	wc.lpfnWndProc 		= &WndProc()
	wc.hInstance 			= hInst
	wc.hIcon 					= LoadIconW (0, $$IDI_APPLICATION)
	wc.hCursor 				= LoadCursorW (0, $$IDC_ARROW)
	wc.hbrBackground 	= $$COLOR_WINDOW 
	wc.lpszClassName 	= &className$

	RETURN (RegisterClassW (&wc) <> 0)

END FUNCTION

FUNCTION WndProc (hWnd, msg, wParam, lParam)

	SELECT CASE msg
		CASE $$WM_DESTROY :
				PostQuitMessage (0)
	END SELECT
	
	RETURN DefWindowProcW (hWnd, msg, wParam, lParam)

END FUNCTION

FUNCTION ButtonWndProc (hWnd, msg, wParam, lParam)

	SHARED mainHwnd
	SHARED butOldProc

	SELECT CASE msg
		CASE $$WM_LBUTTONUP:
			text$  = XstAnsiToUnicode$ ("You clicked the button!")
			title$ = XstAnsiToUnicode$ ("My App Message")
			MessageBoxW (mainHwnd, &text$, &title$, $$MB_OK | $$MB_ICONEXCLAMATION) 
	END SELECT
   
	RETURN CallWindowProcW (butOldProc, hWnd, msg, wParam, lParam)

END FUNCTION

END PROGRAM
